#include	"x68sound/x68sound.h"
// AC`FCe[u\̂`
// \̂̃ACg2ɂ
#pragma pack(push,2)
struct _chain {
	void *addr;
	unsigned short len;
};

// NAC`FCe[u\̂`
// \̂̃ACg2ɂ
struct _chain2 {
	void *addr;
	unsigned short len;
	struct _chain2 *next;
};
#pragma pack(pop)

class X68SoundIOCS : public X68Sound
{
public:
	/* override methods */
	int StartPcm(int samprate=44100, int opmflag=1, int adpcmflag=1, int pcmbuf=5, bool lpf = true);

	X68SoundIOCS();
	~X68SoundIOCS();
	void opmset(int addr, int data);
	int opmsns();
	int opmintst(void *addr);
	void adpcmout(void *addr, int mode, int len);
	void adpcmaot(struct _chain *tbl, int mode, int cnt);
	void adpcmlot(struct _chain2 *tbl, int mode);
	void adpcmcot(void *addr, int mode, int len);
	int adpcmsns();
	void adpcmmod(int mode);

private:
	void DmaIntProc();
	void DmaErrIntProc();
	void SetAdpcmMode(unsigned short mode, unsigned char ccr);
	void AdpcmoutMain(unsigned char stat, unsigned short mode, unsigned short len, unsigned char *adrs);
	void OpmWaitBUSY();
public:

	volatile unsigned char OpmReg1B;

private:
	volatile unsigned char AdpcmStat;
	volatile unsigned char DmaErrCode;
	volatile unsigned char *Adpcmcot_adrs;
	volatile int	Adpcmcot_len;

	void (CALLBACK *OpmIntProc)(void *);
	void *OpmIntPara;

	friend void CALLBACK DmaIntProc(void *para);
	friend void CALLBACK DmaErrIntProc(void *para);
};
