#define	NODEBUG

#define	PRECISION_BITS	(10)
#define	PRECISION	(1<<PRECISION_BITS)
#define	SIZEALPHATBL_BITS	(10)
#define	SIZEALPHATBL	(1<<SIZEALPHATBL_BITS)

#define	SIZESINTBL_BITS	(10)
#define	SIZESINTBL	(1<<SIZESINTBL_BITS)
#define	MAXSINVAL	(1<<(SIZESINTBL_BITS+2))

#define	PI	3.1415926535897932

#define	N_CH	8
#define	PCM8_NCH	8

typedef struct {
	int	and;
	int	add;
}	XR_ELE;

__inline static unsigned char *bswapl(unsigned char *adrs) {
	unsigned char *r;
	__asm {
		mov	eax,adrs
		bswap	eax
		mov r,eax
	}
	return r;
}

__inline static unsigned short bswapw(unsigned short data) {
	unsigned short r;
	__asm {
		mov ax,data
		ror ax,8
		mov r,ax
	}
	return r;
}

